/*****************************************************************************
 *   Copyright (C) 2009 Peter "woggle" Mack, mac@denich.net                  *
 *   Copyright (C) 2011 Christian Brandtner brandtner@brandtner.net          *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License.          *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 *   																		 *
 *   Einstellen der Variablen Parameter des P-MKTool				         *
 *                                                                           *
 *****************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <string.h>
#include <util/delay.h>
#include <stdbool.h>

#include "main.h"
#include "setup.h"
#include "lcd.h"
#include "eeprom.h"
#include "timer.h"
#include "menu.h"
#include "Wi232.h"
#include "bluetooth.h"


uint8_t spalte;
uint8_t mmode;
uint8_t zeile;
uint8_t edit;
uint8_t MenuItems;
//uint8_t LCD_Ausrichtung;
uint8_t edit =0;
uint8_t LCD_Change = 0;
uint8_t Wi_Change =0;
uint8_t BT_Change =0;
uint8_t PKT_Change =0;
;


//

#define ITEMS_PKT 18

prog_char param_menuitems_pkt[ITEMS_PKT][17]= // zeilen,zeichen+1
{
	"Setup Wi/Kabel ",
	"LowBat Warnung ",
	"DisplayTimeout ",
	"Wi TX/RX Channl",
	"Wi NetW. Group ",
	"Wi NetW. Mode  ",
	"Wi TX Timeout  ",
	"Wi TX MTU      ",
	"LCD Orient.    ",
	"LCD Norm/Rev   ",
	"LCD Kontrast   ",
	"LCD Helligk.   ",
	"Language       ",
	"PKT Update     ",
	"PKT Version    ",
	"PC-Config Wi232",
	"Debug PKT      ",
	"Delete EEProm  "
};


//1. Normalbetrieb mit USB und Wi232
//
//2. normalbetrieb mit BT und Wi232
//
//3. betrieb mit USB und kabel an SV2
//
//4. betrieb mit BT und kabel an SV2
//
//5.mkusb funktion mit USB
//
//6. Mkusb Funktion mit BT
//
//7. MKusb funktion mit USB und Wi232
//
//8 mkusb funktion mit BT und wi



#define ITEMS_PROFILE 12

prog_char param_profiles[ITEMS_PROFILE][15]= // zeilen,zeichen+1
{
	"PKT    Wi.232",
	"PKT Kabel SV2",
	"USB MKUSB SV2",
	"BT  MKUSB SV2",
	"USB MKUSB Wi ",
	"BT  MKUSB Wi ",
};


void Show_Error_HW12(void)
{
	lcd_cls();
	lcd_printpns_at (0,3,PSTR("  Mit Hardware 1.2"), 2);
	lcd_printpns_at (0,4,PSTR("   nicht moeglich"), 2);
	_delay_ms(1000);

}



/***********************************************************************************************//***********************************************************************************************/
uint8_t Edit_Int10th_Value(uint8_t Value, uint8_t min, uint8_t max,const char *Text)

{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);
	write_ndigit_number_u_10th (16, 2,Value, 3, 0);

	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
			if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value < max))
			 {
				edit=1;
				Value++;
				write_ndigit_number_u_10th (16, 2,Value, 3, 0);
			 }
			if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value > min))
			 {
				edit=1;
				Value--;
				write_ndigit_number_u_10th (16, 2,Value, 3, 0);
			 }
			if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
	return Value;

}


/***********************************************************************************************//***********************************************************************************************/
uint8_t Edit_Int_Value(uint8_t Value, uint8_t min, uint8_t max,const char *Text)

{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);
	write_ndigit_number_u (16, 2, Value, 3, 0);

	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
			if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value < max))
			 {
				edit=1;
				Value++;
//				write_ndigit_number_u (16, 2,Value, 3, 0);

			 }
			if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value > min))
			 {
				edit=1;
				Value--;
//				write_ndigit_number_u (16, 2,Value, 3, 0);

			 }
			write_ndigit_number_u (16, 2,Value, 3, 0);

			if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
       return Value;

}
/***********************************************************************************************//***********************************************************************************************/
uint8_t ChangeWi_SV2(uint8_t Value, uint8_t min, uint8_t max,const char *Text)

{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);
	 switch (Value)
		    {
		       case	0x0 :lcd_printpns_at (15, 2, PSTR("Wi232"), 0);break;
		       case	0x1 :lcd_printpns_at (15, 2, PSTR("SV2  "), 0);break;
		       break;
		    }

	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
		if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value == 0))
		 {
			edit=1;
			Value=1;
		    lcd_printpns_at (15, 2, PSTR("SV2  "), 0);
		 }
		if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value == 1))
		 {
			edit=1;
			Value=0;
		    lcd_printpns_at (15, 2, PSTR("Wi232"), 0);
		 }
		if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
       return Value;

}

/***********************************************************************************************//***********************************************************************************************/
uint8_t ChangeUSBBT(uint8_t Value, uint8_t min, uint8_t max,const char *Text)

{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);

	 switch (Value)
		    {
		       case	0x0 :lcd_printpns_at (15, 2, PSTR("USB"), 0);break;
		       case	0x1 :lcd_printpns_at (15, 2, PSTR("BT "), 0);break;
		       break;
		    }

	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
		if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value == 0))
		 {
			edit=1;
			Value=1;
		    lcd_printpns_at (15, 2, PSTR("BT "), 0);
		 }
		if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value == 1))
		 {
			edit=1;
			Value=0;
		    lcd_printpns_at (15, 2, PSTR("USB"), 0);
		 }
		if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
       return Value;

}

/***********************************************************************************************//***********************************************************************************************/
uint8_t Edit_Wi_NetMode_Value(uint8_t Value, uint8_t min, uint8_t max,const char *Text)

{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);
	 switch (Value)
		    {
		       case	0x0 :lcd_printpns_at (15, 2, PSTR("Slave "), 0);break;
		       case	0x1 :lcd_printpns_at (15, 2, PSTR("Normal"), 0);break;
		       break;
		    }

	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
		if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value == 0))
		 {
			edit=1;
			Value=NetMode_Normal;
		    lcd_printpns_at (15, 2, PSTR("Normal"), 0);
		 }
		if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value == 1))
		 {
			edit=1;
			Value=NetMode_Slave;
		    lcd_printpns_at (15, 2, PSTR("Slave "), 0);
		 }
		if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
       return Value;

}


/***********************************************************************************************//***********************************************************************************************/
uint8_t Edit_Language(uint8_t Value, uint8_t min, uint8_t max,const char *Text)

{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);
	 switch (Value)
		    {
		       case	0x0 :lcd_printpns_at (14, 2, PSTR("Deutsch"), 0);break;
		       case	0x1 :lcd_printpns_at (14, 2, PSTR("France"), 0);break;
		       case	0x2 :lcd_printpns_at (14, 2, PSTR("English"), 0);break;
		       break;
		    }
	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
			if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value < max))
			 {
				edit=1;
				Value++;
				 switch (Value)
					    {
					       case	0x0 :lcd_printpns_at (14, 2, PSTR("Deutsch"), 0);break;
					       case	0x1 :lcd_printpns_at (14, 2, PSTR("France "), 0);break;
					       case	0x2 :lcd_printpns_at (14, 2, PSTR("English"), 0);break;
					       break;
					    }
			 }
			if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value > min))
			 {
				edit=1;
				Value--;
				 switch (Value)
					    {
						   case	0x0 :lcd_printpns_at (14, 2, PSTR("Deutsch"), 0);break;
						   case	0x1 :lcd_printpns_at (14, 2, PSTR("France "), 0);break;
						   case	0x2 :lcd_printpns_at (14, 2, PSTR("English"), 0);break;
						   break;
					    }
			 }
			if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
       return Value;

}



/***********************************************************************************************/

uint8_t Edit_Orientation(uint8_t Value, uint8_t min, uint8_t max,const char *Text)

{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);
    switch (Value)
    {
       case	0x0 :lcd_printpns_at (14, 2, PSTR("Normal "), 0);break;
       case	0x4 :lcd_printpns_at (14, 2, PSTR("Reverse"), 0);break;
       break;
    }
	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
			if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value == 0))
			 {
				edit=1;
				Value=4;
			    lcd_printpns_at (14, 2, PSTR("Reverse"), 0);
			 }
			if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value == 4))
			 {
				edit=1;
				Value=0;
			    lcd_printpns_at (14, 2, PSTR("Normal "), 0);
			 }
			if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
       return Value;

}

//***********************************************************************************************
uint8_t Edit_DisplayHelligkeit(uint8_t Value, uint8_t min, uint8_t max,const char *Text)

{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);
	write_ndigit_number_u (16, 2, Value, 3, 0);
	lcd_printpns_at (0, 5, PSTR("nicht implementiert"), 0);
	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
			if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value < max))
			 {
				edit=1;
				Value++;


			 }
			if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value > min))
			 {
				edit=1;
				Value--;

			 }
			write_ndigit_number_u (16, 2,Value, 3, 0);

			if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
       return Value;

}

//***********************************************************************************************
uint8_t Edit_DisplayKontrast(uint8_t Value, uint8_t min, uint8_t max,const char *Text)
{
	lcd_cls();
	lcd_printpns_at (0, 2, Text, 0);
	write_ndigit_number_u (16, 2, Value, 3, 0);
	lcd_printpns_at (0, 7, PSTR(" \x18    \x19     Back   "), 0);
	do
		{
			if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (Value < max))
			 {
				edit=1;
				Value++;
				cli();
				clr_A0 ();
				send_byte (0x81);
				send_byte (Value);	// Daten zum LCD senden
				set_A0 ();
				sei();

			 }
			if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (Value > min))
			 {
				edit=1;
				Value--;
				cli();
				clr_A0 ();
				send_byte (0x81);
				send_byte (Value);	// Daten zum LCD senden
				set_A0 ();
				sei();

			 }
			write_ndigit_number_u (16, 2,Value, 3, 0);

			if (get_key_press (1 << KEY_ENTER))	{;}
		}
		while (!get_key_press (1 << KEY_ESC));
       return Value;

}

void Delete_EEprom(void)

{
	lcd_cls();
	if (Debug)
	{
	  do
	  {
		lcd_printpns_at (0, 2, PSTR("  EEProm wirklich    "), 2);
		lcd_printpns_at (0, 3, PSTR("     LOESCHEN??      "), 2);
		lcd_printpns_at (0, 7, PSTR("Delete          Back "), 0);
		if (get_key_press (1 << KEY_MINUS)) Delete_EEPROM();
	  }
	  while (!get_key_press (1 << KEY_ENTER));
	}
	else
	 {
		lcd_printpns_at (0, 2, PSTR("EEProm loeschen nur  "), 0);
		lcd_printpns_at (0, 3, PSTR("im Debugmode moeglich"), 0);
		_delay_ms(1500);
	 }
}



//***********************************************************************************************
void PKT_Setup (void)
{
	uint8_t ii = 0;

	uint8_t size = 0;
	size = ITEMS_PKT ;
	uint8_t dmode = 0;
	uint8_t target_pos = 1;

	uint8_t Offset = 0;
	uint8_t val;

	lcd_cls ();
	mmode = 0;
	edit=0;
	LCD_Change =0;
	Wi_Change =0;
	BT_Change =0;
	zeile = 1;
	MenuItems =2;
//	LCD_Ausrichtung = LCD_ORIENTATION;
	val = 0;


		while(1)
	{
		lcd_cls ();
		lcd_printp_at (0, 0, PSTR("PKT-Tool Setup"), 0);
		lcd_printpns_at (0, 7, PSTR(" \x1a    \x1b     Back   \x0c"), 0);
		while(1)
		{
			ii = 0;
			if(Offset > 0)
			{
				lcd_printp_at(1,1, PSTR("\x1a"), 0);
			}
			for(ii = 0;ii < 6 ; ii++)
			{
				if((ii+Offset) < size)
				{
		    	 lcd_printp_at(3,ii+1,param_menuitems_pkt[ii+Offset], 0);
				}
				if((ii == 5)&&(ii+Offset < (size-1)))
				{
					lcd_printp_at(1,6, PSTR("\x1b"), 0);
				}
			}

			if(dmode == 0)
			{
				if(Offset == 0)
				{
					if(size > 6)
					{
						val = menu_choose2 (1, 5, target_pos,0,1);
					}
					else
					{
						val = menu_choose2 (1, size, target_pos,0,0);
					}
				}
				else
				{
					val = menu_choose2 (2, 5, target_pos,1,1);
				}
			}
			if(dmode == 1)
			{
				if(Offset+7 > size)
				{
					val = menu_choose2 (2, 6, target_pos,1,0);
				}
				else
				{
					val = menu_choose2 (2, 5, target_pos,1,1);
				}
			}

			if(val == 254)
			{
				Offset++;
				dmode = 1;
				target_pos = 5;
			}else if(val == 253)
			{
				Offset--;
				dmode = 0;
				target_pos = 2;
			}else if(val == 255)
			{	/* Ende mit BACK, speichern */
				if  (edit==1)
				{
				 WriteParameter();
				  if (LCD_Change)
					{
					cli();
					LCD_Init(1);

					sei();
					}
#ifdef HWVERSION3_9
				  if (Wi_Change) InitWi232();

				  if (BT_Change)
				  	  {

					    if (USBBT==0) set_USBOn();
					    else
					    	{
					    	 set_BTOn();    // USB ein, BT aus
					    	 lcd_cls();
					    	 if (BTIsSet==true)
					    	 {
					    	    lcd_printpns_at (0, 4, PSTR("BT eingeschaltet"),1);
					    	    lcd_printpns_at (0, 5, PSTR("warte ......"),1);
					     	   _delay_ms(3000);
					    	 }
					    	 else
					    	 {
								 lcd_printpns_at (0, 0, PSTR("Bluetooth Init...wait"),1);
								 _delay_ms(2000);
								 if (bt_init())
									{
									 lcd_printpns_at (0, 2, PSTR("Bluetooth OK"),2);
									 WriteBTInitFlag();
									 _delay_ms(2000);
									}
								 else
								 {
									 lcd_printpns_at (0, 2, PSTR("Bluetooth Fehler"),2);
									  beeptime = 1000;
									  BeepMuster = 0x0040;
									 _delay_ms(2000);
								 }
					    	 }
					       }
					  }
#endif
				  if (PKT_Change)
				  {
#ifdef HWVERSION3_9
					if (U02SV2==1)  Change_Output(Uart02FC);
					else Change_Output(Uart02Wi);
#endif
				  }
				}
				return;
			}
			else
			{
				break;
			}
		}

//
//	1	"Setup Wi/Kabel ",
//	2	"LowBat Warnung ",
//	3	"DisplayTimeout ",
//	4	"Wi TX/RX Channl",
//	5	"Wi NetW. Group ",
//	6	"Wi NetW. Mode  ",
//	7	"Wi TX Timeout  ",
//	8	"Wi TX MTU      ",
//	9	"LCD Orient.    ",
//	0	"LCD Norm/Rev   ",
//	1	"LCD Kontrast   ",
//	2	"LCD Helligk.   ",
//	3	"Language       ",
//	4	"PKT Update     ",
//	5	"PKT Version?   ",
//	6	"PC-Config Wi232",
//	7	"Debug PKT      ",
//	8	"Delete EEProm  "

		target_pos = val;
//		if((val+Offset) == 1 )  {
//#ifdef HWVERSION3_9
//								 USBBT = ChangeUSBBT(USBBT,0,1,PSTR("Connect PC to :"));
//								 if (edit==1) BT_Change =1;
//#else
//								 Show_Error_HW12();
//#endif
//								}
		if((val+Offset) == 1 )  {
#ifdef HWVERSION3_9
								 U02SV2 = ChangeWi_SV2(U02SV2,0,1,PSTR("Connect PKT to:"));
								 if (edit==1) PKT_Change =1;
#else
								 Show_Error_HW12();
#endif
								}

		if((val+Offset) == 2 )  MK_LowBat = Edit_Int10th_Value(MK_LowBat,33,170,PSTR("LowBat Warn V:"));
		if((val+Offset) == 3 )  DisplayTimeout = Edit_Int_Value(DisplayTimeout,0,254,PSTR("Disp.Timeout :"));
		if((val+Offset) == 4 )  {
#ifdef HWVERSION3_9
								 WiTXRXChannel =  Edit_Int_Value(WiTXRXChannel,0,5,PSTR("Wi TX/RX Chan:"));
								 if (edit==1) if(!Wi_Change) Wi_Change =1;
#else
								 Show_Error_HW12();
#endif
								}
		if((val+Offset) == 5 )  {
#ifdef HWVERSION3_9
								 WiNetworkGroup = Edit_Int_Value(WiNetworkGroup,0,127,PSTR("Wi NetW. Grp.:"));
								 if (edit==1) if(!Wi_Change) Wi_Change =1;
#else
								 Show_Error_HW12();
#endif
								}
		if((val+Offset) == 6 )  {
#ifdef HWVERSION3_9
								 WiNetworkMode =  Edit_Wi_NetMode_Value(WiNetworkMode,0,1,PSTR("Wi NetW. Mode:"));
								 if (edit==1) if(!Wi_Change) Wi_Change =1;
#else
								 Show_Error_HW12();
#endif
								}
		if((val+Offset) == 7)  {
#ifdef HWVERSION3_9
								 WiTXTO = Edit_Int_Value(WiTXTO,0,127,PSTR("Wi TX Timeout:"));
								 if (edit==1) if(!Wi_Change) Wi_Change =1;
#else
								 Show_Error_HW12();
#endif
								}
		if((val+Offset) == 8)  {
#ifdef HWVERSION3_9
								 WiUartMTU = Edit_Int_Value(WiUartMTU,0,127,PSTR("Wi UART MTU   :"));
								 if (edit==1) if(!Wi_Change) Wi_Change =1;
#else
								 Show_Error_HW12();
#endif
								}


		if((val+Offset) == 9 )  {
								 LCD_ORIENTATION = Edit_Orientation(LCD_ORIENTATION,0,4,PSTR("LCD Orient.: "));
								 if (edit==1) if(!LCD_Change) LCD_Change =1;
								}
		if((val+Offset) == 10 )  {
								 LCD_DisplayMode = Edit_Orientation(LCD_DisplayMode,0,4,PSTR("LCD Norm/Rev: "));
								 if (edit==1) if(!LCD_Change) LCD_Change =1;
							     }

		if((val+Offset) == 11)  LCD_Kontrast =  Edit_DisplayKontrast(LCD_Kontrast,0,63,PSTR("LCD Kontrast:"));

		if((val+Offset) == 12)  LCD_Helligkeit =  Edit_DisplayHelligkeit(LCD_Helligkeit,0,127,PSTR("LCD Helligk.:"));


		if((val+Offset) == 13)  DisplayLanguage = Edit_Language(DisplayLanguage,0,2,PSTR("Language   : "));
		if((val+Offset) == 14)  Update_PKT();
		if((val+Offset) == 15)  Show_Version();
		if((val+Offset) == 16)	Port_USB2_CFGWi();
		if((val+Offset) == 17)  Debug =  Edit_Int_Value(Debug,0,1,PSTR("Set PKT Debug:"));


		if((val+Offset) == 18)  Delete_EEprom();






	}
}








